#include "smtp.h"

// S:2005-08-29 gorila@dione.zcu.cz
int smtp_out_packets_iq(smtpp par, char *type)
   {
   int liProcess=0;
   jpacket jp=par->jp;
   smtpi sin=par->sin;
   time_t now_unixtime;
   struct tm now;
   char lcPom[27];
   char *lcJID, *lcPercent,*lcAT,*lcLang;
   struct utsname osinfo;
   spool osinfos;
   xmlnode x, loQuery, loIdentity, loStat, loStatN;



   lcLang=xmlnode_get_attrib(jp->x, "xml:lang");

   if (liProcess==0 && 
       j_strcmp(xmlnode_get_attrib(jp->x, "id"),"smtp_test_jep0033")==0 &&
       j_strcmp(jp->iqns,"http://jabber.org/protocol/disco#info")==0)
      {

      if (xmlnode_get_tag(jp->x,"query/feature?var=http://jabber.org/protocol/address"))
         sin->jep0033=1;

      return -1;
      }

   
   if (liProcess==0 && j_strcmp(jp->iqns,NS_VERSION)==0 && jp->subtype==JPACKET__GET)
      {
      x= out_SetReply(xmlnode_new_tag("iq"),jp->x);
      xmlnode_put_attrib(x,"type","result");
      xmlnode_put_attrib(loQuery=xmlnode_insert_tag(x,"query"),"xmlns",NS_VERSION);
      xmlnode_insert_cdata(xmlnode_insert_tag(loQuery,"name"),smtp_name,-1);
      xmlnode_insert_cdata(xmlnode_insert_tag(loQuery,"version"),smtp_version,-1);
 
      uname(&osinfo);
      osinfos = spool_new(sin->i->p);
      spooler(osinfos,osinfo.sysname, " ", osinfo.release, " ", osinfo.machine,osinfos);

      xmlnode_insert_cdata(xmlnode_insert_tag(loQuery,"os"), spool_print(osinfos) ,-1);

      liProcess=1;
      }



   if (liProcess==0 && j_strcmp(jp->iqns,NS_GATEWAY)==0 && jp->subtype==JPACKET__GET && jp->to->user==NULL)
      {
      x= out_SetReply(xmlnode_new_tag("iq"),jp->x);
      xmlnode_put_attrib(x,"type","result");
      xmlnode_put_attrib(loQuery=xmlnode_insert_tag(x,"query"),"xmlns",NS_GATEWAY);

      if (0==1 || j_strcmp(lcLang,"cs")==0)
         {
         xmlnode_insert_cdata(xmlnode_insert_tag(loQuery,"desc"),SMTP_GATEWAY_DESCR_CS,-1);
         xmlnode_insert_cdata(xmlnode_insert_tag(loQuery,"prompt"),SMTP_GATEWAY_PROMPT_CS,-1);
/*
         xmlnode_insert_cdata(xmlnode_insert_tag(loQuery,"desc"),smtp_ToUTF8(par->i->p,SMTP_GATEWAY_DESCR_CS,"win1250"),-1);
         xmlnode_insert_cdata(xmlnode_insert_tag(loQuery,"prompt"),smtp_ToUTF8(par->i->p,SMTP_GATEWAY_PROMPT_CS,"win1250"),-1);
*/
         }      

      if (lcLang==NULL || j_strcmp(lcLang,"en")==0)
         {
         xmlnode_insert_cdata(xmlnode_insert_tag(loQuery,"desc"),"Please enter the e-mail address of the person you would like to contact.",-1);
         xmlnode_insert_cdata(xmlnode_insert_tag(loQuery,"prompt"),"firstname.lastname@firm.com",-1);
         }      

      liProcess=1;
      }


   if (liProcess==0 && j_strcmp(jp->iqns,NS_GATEWAY)==0 && jp->subtype==JPACKET__SET && jp->to->user==NULL)
      {
      x= out_SetReply(xmlnode_new_tag("iq"),jp->x);
      // check prompt element data
      /* translate the recipient into a SMTP address */
      lcJID = xmlnode_get_data(xmlnode_get_tag(jp->x,"query/prompt"));
      lcPercent = strstr(lcJID,"%");
      lcAT = strstr(lcJID,"@");
      
      if (lcPercent==NULL && lcAT==NULL)
         {
         smtp_ReplyError(par, jp, "iq", "Bad address", 405);
         }

      else
         {
         if (lcPercent!=NULL && lcAT!=NULL) // define % and @
            {
            if (lcPercent<lcAT) // % is before @
               *lcAT='\0';
            else
               {
               *lcPercent='\0';
               *lcAT='%';
               }
            }
         else    
            if (lcAT!=NULL)
               *lcAT='%';

         xmlnode_put_attrib(x,"type","result");
         xmlnode_put_attrib(loQuery=xmlnode_insert_tag(x,"query"),"xmlns",NS_GATEWAY);
         xmlnode_insert_cdata(xmlnode_insert_tag(loQuery,"prompt"),strcat(strcat(lcJID,"@"),xmlnode_get_attrib(jp->x,"to")),-1);
         }

      liProcess=1;
      }


   if (liProcess==0 && j_strcmp(jp->iqns,NS_TIME)==0 && jp->subtype==JPACKET__GET)
      {
      x= out_SetReply(xmlnode_new_tag("iq"),jp->x);
      xmlnode_put_attrib(x,"type","result");
      xmlnode_put_attrib(loQuery=xmlnode_insert_tag(x,"query"),"xmlns",NS_TIME);

      /* create UTC time */
      now_unixtime = time(NULL);
      gmtime_r(&now_unixtime, &now);
      lcPom[0]='\0';
      snprintf(lcPom, sizeof(lcPom), "%02i %s %04i %02i:%02i:%02i +0000", now.tm_mday, smtp_CMonth(now.tm_mon), now.tm_year+1900, now.tm_hour, now.tm_min, now.tm_sec);
      if (lcPom[0])
         xmlnode_insert_cdata(xmlnode_insert_tag(loQuery,"display"),lcPom,27);


      lcPom[17]='\0';
      snprintf(lcPom, sizeof(lcPom), "%04i%02i%02iT%02i:%02i:%02i", now.tm_year+1900, now.tm_mon, now.tm_mday, now.tm_hour, now.tm_min, now.tm_sec);
      if (lcPom[0])
          xmlnode_insert_cdata(xmlnode_insert_tag(loQuery,"utc"),lcPom,-1);

      liProcess=1;
      }


   if (liProcess==0 && j_strcmp(jp->iqns,NS_VCARD)==0 && jp->subtype==JPACKET__GET)
      {
      x= out_SetReply(xmlnode_new_tag("iq"),jp->x);
      xmlnode_put_attrib(x,"type","result");
      xmlnode_put_attrib(loQuery=xmlnode_insert_tag(x,"vCard"),"xmlns",NS_VCARD);
      xmlnode_insert_cdata(xmlnode_insert_tag(loQuery,"JABBERID"),xmlnode_get_attrib(jp->x,"to"),-1);
      if (jp->to->user==NULL)
         xmlnode_insert_cdata(xmlnode_insert_tag(loQuery,"FN"),smtp_name,-1);

      liProcess=1;
      }

   if (liProcess==0 && j_strcmp(jp->iqns,"http://jabber.org/protocol/disco#info")==0 && jp->subtype==JPACKET__RESULT)
      {

      }


   if (liProcess==0 && j_strcmp(jp->iqns,"http://jabber.org/protocol/disco#info")==0 && jp->subtype==JPACKET__GET)
      {
      x= out_SetReply(xmlnode_new_tag("iq"),jp->x);
      xmlnode_put_attrib(x,"type","result");

      xmlnode_put_attrib(loQuery=xmlnode_insert_tag(x,"query"),"xmlns","http://jabber.org/protocol/disco#info");


      xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"feature"),"var","http://jabber.org/protocol/disco");

      if (jp->to->user==NULL)
         {

         xmlnode_put_attrib(loIdentity=xmlnode_insert_tag(loQuery,"identity"),"category","gateway");
         xmlnode_put_attrib(loIdentity,"name",smtp_name);
         xmlnode_put_attrib(loIdentity,"type","x-smtp");

         xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"feature"),"var","http://jabber.org/protocol/stats");
         xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"feature"),"var","http://jabber.org/protocol/address");
         xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"feature"),"var","jabber:iq:gateway");
         }
      else
         xmlnode_put_attrib(loIdentity=xmlnode_insert_tag(loQuery,"identity"),"category","client");


      xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"feature"),"var","jabber:iq:version");
      xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"feature"),"var","jabber:iq:time");
      xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"feature"),"var","vcard-temp");


      liProcess=1;
      }


   if (liProcess==0 && j_strcmp(jp->iqns,"http://jabber.org/protocol/stats")==00 &&
       jp->subtype==JPACKET__GET && jp->to->user==NULL)
      {
      x= out_SetReply(xmlnode_new_tag("iq"),jp->x);
      xmlnode_put_attrib(x,"type","result");

      xmlnode_put_attrib(loQuery=xmlnode_insert_tag(x,"query"),"xmlns","http://jabber.org/protocol/stats");

      if ((loStat=xmlnode_get_firstchild(jp->iq)))
         {


         // read all childs elements
         for (;loStat != NULL; loStat = xmlnode_get_nextsibling(loStat))
             {
             if (j_strcmp(xmlnode_get_attrib(loStat,"name"),"messages/out")==0)
                {
                xmlnode_put_attrib(loStatN=xmlnode_insert_tag(loQuery,"stat"),"name","messages/out");
                xmlnode_put_attrib(loStatN,"units","messages");
                xmlnode_put_attrib(loStatN,"value",xmlnode_get_attrib(sin->statistics,"messagesout")); 
                continue;
                }

             if (j_strcmp(xmlnode_get_attrib(loStat,"name"),"messages/outerror")==0)
                {
                xmlnode_put_attrib(loStatN=xmlnode_insert_tag(loQuery,"stat"),"name","messages/outerror");
                xmlnode_put_attrib(loStatN,"units","messages");
                xmlnode_put_attrib(loStatN,"value",xmlnode_get_attrib(sin->statistics,"messagesouterror")); 
                continue;
                }

             if (j_strcmp(xmlnode_get_attrib(loStat,"name"),"messages/in")==0)
                {
                xmlnode_put_attrib(loStatN=xmlnode_insert_tag(loQuery,"stat"),"name","messages/in");
                xmlnode_put_attrib(loStatN,"units","messages");
                xmlnode_put_attrib(loStatN,"value",xmlnode_get_attrib(sin->statistics,"messagesin")); 
                continue;
                }

             if (j_strcmp(xmlnode_get_attrib(loStat,"name"),"start")==0)
                {
                xmlnode_put_attrib(loStatN=xmlnode_insert_tag(loQuery,"stat"),"name","start");
                xmlnode_put_attrib(loStatN,"units","count");
                xmlnode_put_attrib(loStatN,"value",xmlnode_get_attrib(sin->statistics,"start")); 
                continue;
                }



             if (j_strcmp(xmlnode_get_attrib(loStat,"name"),"messages/elapsed/out")==0)
                {
                xmlnode_put_attrib(loStatN=xmlnode_insert_tag(loQuery,"stat"),"name","messages/elapsed/out");
                xmlnode_put_attrib(loStatN,"units","messages");

                snprintf(lcPom, sizeof(lcPom), "%i\0",sin->MessagesElapsedOut);
                xmlnode_put_attrib(loStatN,"value",lcPom); 
                continue;
                }


             if (j_strcmp(xmlnode_get_attrib(loStat,"name"),"messages/elapsed/outerror")==0)
                {
                xmlnode_put_attrib(loStatN=xmlnode_insert_tag(loQuery,"stat"),"name","messages/elapsed/outerror");
                xmlnode_put_attrib(loStatN,"units","messages");

                snprintf(lcPom, sizeof(lcPom), "%i\0",sin->MessagesElapsedOutError);
                xmlnode_put_attrib(loStatN,"value",lcPom); 
                continue;
                }

             if (j_strcmp(xmlnode_get_attrib(loStat,"name"),"messages/elapsed/in")==0)
                {
                xmlnode_put_attrib(loStatN=xmlnode_insert_tag(loQuery,"stat"),"name","messages/elapsed/in");
                xmlnode_put_attrib(loStatN,"units","messages");
                snprintf(lcPom, sizeof(lcPom), "%i\0",sin->MessagesElapsedIn);
                xmlnode_put_attrib(loStatN,"value",lcPom);
                continue;
                }


             if (j_strcmp(xmlnode_get_attrib(loStat,"name"),"start/elapsed")==0)
                {
                xmlnode_put_attrib(loStatN=xmlnode_insert_tag(loQuery,"stat"),"name","start/elapsed");
                xmlnode_put_attrib(loStatN,"units","count");

                snprintf(lcPom, sizeof(lcPom), "%i\0",sin->StartElapsed);
                xmlnode_put_attrib(loStatN,"value",lcPom); 
                continue;
                }

             }

         }
      else
         {

         xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"stat"),"name","messages/out");
         xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"stat"),"name","messages/outerror");
         xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"stat"),"name","messages/in");
         xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"stat"),"name","messages/elapsed/out");
         xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"stat"),"name","messages/elapsed/outerror");
         xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"stat"),"name","messages/elapsed/in");
         xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"stat"),"name","start");
         xmlnode_put_attrib(xmlnode_insert_tag(loQuery,"stat"),"name","start/elapsed");
		 
		 }

      liProcess=1;
      }


   if (liProcess==1)
      {
      deliver(dpacket_new(xmlnode_dup(x)),sin->i);
      xmlnode_free(x);
      }


   return liProcess;
   }

// E:2005-08-29 gorila@dione.zcu.cz
